/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui.ComponentBasedUI;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.gui.swingwrappers.UserActionListener;
import org.visnow.vn.gui.swingwrappers.UserEvent;
import org.visnow.vn.gui.widgets.WidePopupComboBox;

/**
 *
 * @author know
 */
public class ComponentFeatureUI extends javax.swing.JPanel
{
    protected boolean userUpdate = true;
    protected ComponentFeature componentFeature = null;
    protected ChangeListener listener = new ChangeListener()
    {
        @Override
        public void stateChanged(ChangeEvent e)
        {
            paramsChange();
        }
    };

    /**
     * Creates new form ComponentFeatureUI
     */
    public ComponentFeatureUI()
    {
        initComponents();
    }

    /**
     * Creates new form ComponentFeatureUI
     * @param showResetButton shows if reset button is visible (and enabled)
     */
    public ComponentFeatureUI(boolean showResetButton)
    {
        initComponents();
        resetButton.setVisible(showResetButton);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        jPanel1 = new JPanel();
        componentSelector = new WidePopupComboBox();
        resetButton = new JButton();

        setLayout(new BorderLayout());

        jPanel1.setLayout(new GridBagLayout());

        componentSelector.addUserActionListener(new UserActionListener()
        {
            public void userAction(UserEvent evt)
            {
            }
            public void userChangeAction(UserEvent evt)
            {
                componentSelectorUserChangeAction(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(componentSelector, gridBagConstraints);

        resetButton.setText("reset");
        resetButton.setMargin(new Insets(2, 2, 2, 2));
        resetButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        jPanel1.add(resetButton, new GridBagConstraints());

        add(jPanel1, BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

   private void resetButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
   {//GEN-HEADEREND:event_resetButtonActionPerformed
       if (componentFeature != null)
           componentFeature.reset();
   }//GEN-LAST:event_resetButtonActionPerformed

    private void componentSelectorUserChangeAction(UserEvent evt)//GEN-FIRST:event_componentSelectorUserChangeAction
    {//GEN-HEADEREND:event_componentSelectorUserChangeAction
        if (componentFeature != null)
            componentFeature.uiSetComponentSchema((String) componentSelector.getSelectedItem());
        updateUIToNewComponent("null".equals(componentSelector.getSelectedItem()));
    }//GEN-LAST:event_componentSelectorUserChangeAction

    public void setComponentFeature(ComponentFeature componentFeature)
    {
        this.componentFeature = componentFeature;
        componentFeature.setUI(this);
        setComponentNames(componentFeature.getComponentNames());
        if (componentFeature.getComponentName() != null)
            componentSelector.setSelectedItem(componentFeature.getComponentName());
        else if (componentFeature.isAddNull())
            componentSelector.setSelectedItem("null");
    }

    public void setComponentNames(String[] componentNames)
    {
        componentSelector.setListData(componentNames);
    }

    public void setSelectedName(String componentName)
    {
        componentSelector.setSelectedItem(componentName);
    }
    
    /**
     * used to notify subclasses of component selection change (to enable/disable gui if null component hasbeen selected) 
     * @param isNull true if null has been selected
     */
    protected void updateUIToNewComponent(boolean isNull)
    {
    }

    protected void paramsChange()
    {
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected WidePopupComboBox componentSelector;
    protected JPanel jPanel1;
    protected JButton resetButton;
    // End of variables declaration//GEN-END:variables
}
